<script>
  import { extent } from "d3-array";
  import { scaleLinear, scaleOrdinal } from "d3-scale";
  import { onMount } from "svelte";
  import { schemeDark2 } from "d3-scale-chromatic";
  import { axisBottom, axisLeft } from "d3-axis";
  import { select } from "d3-selection";
  import Ex7_scatter from "./_ex_7_scatterplot.svelte";

  const width = 600;
  const height = 400;
  let scaleX;
  let scaleY;
  let scaleR;
  let scaleColor;
  let scaleYAxis;
  let xax;
  let yax;
  const margin = 50;

  // Load data
  $: data = ["The data is being loaded"];
  onMount(async () => {
    await fetch("../../../../../data/gapminder.json")
      .then((response) => {
        return response.json();
      })
      .then((from_file) => {
        data = from_file[0].countries;
        console.log("Is in second .then");
        console.log(data);

        // Scales
        
        scaleX = scaleLinear(extent(data.map((item)=> item.income)), [
          margin,
          width+300
        ]).domain([200, 4800]);
        
        scaleY = scaleLinear(extent(data.map((item) => item.life_exp)), [
          margin,
          height
        ])
        .domain([22, 47]);
        scaleYAxis = scaleLinear(extent(data.map((item) => item.life_exp)), [
          height,
          margin
        ]).domain([22, 47]);
       
        scaleR = scaleLinear(
          extent(data.map((item) => item.population)),
          [5, 20]
        );
        scaleColor = scaleOrdinal(
          extent(data.map((item) => item.continent)),
          schemeDark2
        );

        const xAxis = axisBottom().scale(scaleX).tickFormat(d => "$ " +d );
        const yAxis = axisLeft().scale(scaleYAxis);
        select(xax).call(xAxis);
        select(yax).call(yAxis);
        console.log("Finished with then");
      });
  });
</script>

<svg viewBox="0 0 {width+300} {height}">
  <g>
    {#if data == "The data is being loaded"}
      <text transform="translate(100,100)">{data}</text>
    {:else}
      {#each data as point}
        {#if point.income && point.life_exp}
          <circle
            cx={scaleX(point.income)}
            cy={height - scaleY(point.life_exp)}
            r={scaleR(point.population)}
            style="fill: {scaleColor(point.continent)};"
          />
        {/if}
      {/each}
      <text transform="translate({width / 2},{height})">Income</text>
      <text transform="translate(15, {height / 2 + 40}), rotate(-90)"
        >Life expectancy</text
      >
      <text id="title" transform="translate({margin + 100},{30})"
        >Relationship between Life expectancy and GDP</text
      >
      <text class="label" x="705" y="340" style="font-size: 50px;
      font-weight: bold; opacity=0.5; " >1800</text
    >
    {/if}
  </g>
  <g transform="translate(0, {height - margin})" bind:this={xax} />
  <g transform="translate({margin}, {-margin})" bind:this={yax} />
</svg>

<style>
  circle {
    opacity: 0.8;
  }
  svg {
    margin: 20px;
    max-height: 400px;
  }
  text {
    font-size: 15px;
  
  }
  #title {
    font-size: 25px;
    font-weight: bold;
    
  }
  
</style>
